/* common.inc
   Copyright (C) 1994, 1997, 1998  J Dana Eckart
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
  
   You should have received a copy of the GNU General Public License
   along with CELLULAR; see the file COPYING.  If not, write to the 
   Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* The following variables are the lower and upper bounds of the
   dimensions to display.
*/
extern int dim_given, range_dim_1_index, range_dim_2_index, range_dim_3_index;
extern int lower[], upper[];

void bad_arith(int exit_status) {
        fprintf(stderr, "%s: Division by zero (0).\n", command);
	fflush((FILE*) NULL);
        exit_signaled(1);
}

long int mydiv(long int a, long int b) {
        if (a == 0) return 0;
        else {
                long int quotient = labs(a)/labs(b);
                return (((a <= 0 && b <= 0) || (a >= 0 && b >= 0)) ?
                                quotient : -quotient);
        }
}

long int mymod(long int a, long int b) {
        return (a - b * mydiv(a, b));
}

static long int last = 10;

void set_seed(long int seed) {
	last = seed;
}

long int myrandom(void) {
	return last = (1909 * last + 221571) % 65563;
}

float myfrandom(void) {
	last = (1909 * last + 221571) % 65563;
	return ((float) last)/65563.0;
}
