/* scanner.h
   Copyright (C) 1992, 1994, 1999  J Dana Eckart
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
  
   You should have received a copy of the GNU General Public License
   along with CELLULAR; see the file COPYING.  If not, write to the 
   Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "y.tab.h"
#include "boolean.h"

extern boolean scan_error;	/* True iff a scanning error was encountered. */

extern char yytext[];		/* Holds the text of a scanned token. */

extern void startscan(void);	/* Setup for scanning a new file. */

extern int yylex(void);		/* Function used to acquire the next token. */

/* Indicates whether or not floating point operations should be used in
   Cellular Automata computations.
*/
extern boolean use_floats;

/* This variable is used to communicate which of two types of numeric
   literals has just been read by the scanner.
*/
extern boolean NumericIsFloat;
