/* fhp.c
   Copyright (C) 1994, 1995  J Dana Eckart

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with CELLULAR; see the file COPYING.  If not, write to the 
   Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* Generate the input data used to set up hexagonal neighborhoods.  A single 
   command line argument indicates the size of each of two dimensions of the 
   cell universe.
*/

#include <stdio.h>
#include <stdlib.h>
#include "my_rand.h"

/* Except for the "which" field, this code only writes values for the
   top of the hexagon.  Thus the code using this as initial data must
   make sure that the bottom of the hexagon copies the values from the
   top at time 0.
*/

int main(int argc, char *argv[]) {
	int max_size = atoi(argv[1]);
	int x, y;

	printf("0\n");

	for (x = 0; x < max_size; x++)
		for (y = 0; y < max_size; y++) {

			/* Write cell location. */
			printf("[%d, %d] = ", x, y);

			/* Write "which" field value. */
			if (y%2 == 0)
				printf("1");
			else
				printf("0");

			if ((x-(max_size/2))*(x-(max_size/2)) +
				(y-(max_size/2))*(y-(max_size/2)) > max_size) {
				/* Particle(s)! */
				int n=0, ne=0, se=0, s=0, sw=0, nw=0;

				/* Chance that a particle is placed. */
				int fill;

				fill = my_random()%100;
				if (fill < 65) n = 1;
				fill = my_random()%100;
				if (fill < 65) ne = 1;
				fill = my_random()%100;
				if (fill < 65) se = 1;
				fill = my_random()%100;
				if (fill < 65) s = 1;
				fill = my_random()%100;
				if (fill < 65) sw = 1;
				fill = my_random()%100;
				if (fill < 65) nw = 1;

				printf(", %d, %d, %d, %d, %d, %d, %d",
					n+ne+se+s+sw+nw, n, ne, se, s, sw, nw);
		}
		printf("\n");
	}

	return 0;
}
